package nl.kallestruik.dlib

import org.bukkit.util.Vector
import java.util.*

class DUtil(
    private val random: Random
) {

    /**
     * Create a random vector with integer offsets within the min and max.
     * @param min The minimum offset.
     * @param max The maximum offset.
     * @param height Whether the height should also have a random offset.
     * @return A [Vector] containing the offsets.
     */
    fun getRandomLocationOffset(min: Int, max: Int, height: Boolean): Vector {
        // Create the vectors with all positive numbers.
        val vec = if (height) {
            Vector(
                min + random.nextInt(max - min),
                min + random.nextInt(max - min),
                min + random.nextInt(max - min)
            )
        } else {
            Vector(
                min + random.nextInt(max - min),
                0,
                min + random.nextInt(max - min)
            )
        }

        // Randomly make some components negative instead of positive.
        vec.multiply(
            Vector(
                if (random.nextBoolean()) -1 else 1,
                if (random.nextBoolean()) -1 else 1,
                if (random.nextBoolean()) -1 else 1
            )
        )

        // Return the completed vector.
        return vec
    }
}